@mixin high-contrast-button-outline($outline: 2px dotted) {
  @media (-ms-high-contrast: active) {
    outline: $outline;
  }
}

@mixin button-base {
  --p-button-drop-shadow: 0px 2px 2px rgba(0, 0, 0, 0.102874);
  --p-border-radius-base: 0.5rem;
  --p-border-neutral-subdued: #f0f0f0;

  $min-height: control-height();
  $vertical-padding: (control-height() - line-height(pad) - rem(2px)) / 2;

  @include recolor-icon(var(--p-icon));
  @include focus-ring($border-width: border-width('base'));
  position: relative;
  display: inline-flex;
  align-items: center;
  justify-content: center;
  min-height: $min-height;
  min-width: $min-height;
  margin: 0;
  padding: $vertical-padding spacing();
  background: var(--p-surface);
  box-shadow: var(--p-button-drop-shadow);
  border-radius: var(--p-border-radius-base);
  color: var(--p-text);
  border: 1px solid var(--p-border-neutral-subdued);
  // border-top-color: var(--p-border-subdued);
  // border-bottom-color: var(--p-border-shadow-subdued);
  line-height: 1;
  text-align: center;
  cursor: pointer;
  user-select: none;
  text-decoration: none;
  -webkit-tap-highlight-color: transparent;

  &:hover {
    --p-action-secondary-hovered: linear-gradient(
        180deg,
        #f9f9fb 0%,
        #ffffff 50.52%,
        #f2f4fa 100%
      ),
      #ffffff;

    background: var(--p-action-secondary-hovered);
    @include high-contrast-outline;
  }

  &:focus {
    box-shadow: var(--p-button-drop-shadow);
    outline: 0;

    @include no-focus-ring;
  }

  &:active {
    --p-button-drop-shadow: inset 0px 0px 4px rgba(0, 0, 0, 0.202633);
    background: var(--p-action-secondary-pressed);

    &::after {
      border: none;
      box-shadow: none;
    }
  }

  &.pressed {
    border: 0.1rem solid black;
    background: var(--p-action-secondary-depressed);
    box-shadow: var(--p-button-pressed-inner-shadow);
    color: var(--p-text);
    border-color: var(--p-border-depressed);
    @include recolor-icon(currentColor);
  }

  @media (-ms-high-contrast: active) {
    border: 1px solid ms-high-contrast-color('text');
  }
}

@mixin base-button-disabled {
  --p-surface-disabled: linear-gradient(to bottom, #f4f6f8, #f4f6f8);
  --p-text-disabled: #919eab;

  @include recolor-icon(var(--p-icon-disabled));
  transition: none;
  box-shadow: none;
  border-color: var(--p-border-disabled);
  background: var(--p-surface-disabled);
  color: var(--p-text-disabled);
  cursor: not-allowed;
}

@mixin button-filled() {
  @include no-focus-ring;
  background: var(--p-button-color);
  // border-width: 0;
  border-color: transparent;
  box-shadow: var(--p-button-drop-shadow);
  color: var(--p-button-text);

  &:hover {
    background: var(--p-button-color-hover);
    border-color: transparent;
    color: var(--p-button-text);
  }

  &:focus {
    border-color: transparent;
    box-shadow: var(--p-button-drop-shadow), var(--p-button-inner-shadow);
  }

  &:active {
    background: var(--p-button-color-active);
    border-color: transparent;
    box-shadow: var(--p-button-inner-shadow);
  }

  &.pressed {
    color: var(--p-button-text);
    background: var(--p-button-color-depressed);
    border-color: transparent;
    box-shadow: var(--p-button-inner-shadow);

    &:hover,
    &:focus {
      background: var(--p-button-color-depressed);
      box-shadow: var(--p-button-drop-shadow), var(--p-button-inner-shadow);
    }
  }
}

@mixin button-outline($outline-color, $background-color: transparent) {
  background: transparent;
  border: border-width() solid var(--p-border);
  box-shadow: none;
  color: var(--p-text);
  @include focus-ring($border-width: border-width('base'));

  &:hover {
    border: border-width() solid var(--p-border);
    box-shadow: none;
    background: var(--p-surface-hovered);
  }

  &:focus {
    border: border-width() solid var(--p-border);
    box-shadow: none;
    @include focus-ring($style: 'focused');
  }

  &:active {
    border: border-width() solid var(--p-border);
    box-shadow: none;
    background: var(--p-surface-pressed);
    &::after {
      box-shadow: none;
    }
  }

  &.pressed {
    background: var(--p-action-secondary-pressed);
    border: border-width() solid var(--p-border);
    box-shadow: none;
    color: var(--p-button-text);
  }

  &.disabled {
    border: border-width('base') solid var(--p-border-disabled);
    box-shadow: none;
    background: transparent;
    color: var(--p-text-disabled);
  }

  &.destructive {
    background: transparent;
    border: border-width('base') solid var(--p-border-critical);
    box-shadow: none;
    color: var(--p-interactive-critical);
    @include recolor-icon(var(--p-icon-critical));

    &:hover {
      border: border-width('base') solid var(--p-border-critical);
      background: var(--p-surface-critical-subdued);
    }

    &:focus {
      border: border-width('base') solid var(--p-border-critical);
      @include focus-ring($style: 'focused');
    }

    &:active {
      border: border-width('base') solid var(--p-border-critical);
      background: var(--p-surface-critical-subdued);
    }

    // stylelint-disable-next-line selector-max-class
    &.disabled {
      border: border-width('base') solid var(--p-border-critical-disabled);
      background: transparent;
      color: var(--p-interactive-critical-disabled);
    }

    // stylelint-disable-next-line selector-max-class
    &.pressed {
      background: var(--p-surface-critical-subdued);
      box-shadow: border-width('base') solid var(--p-border-critical);
      color: var(--p-interactive-critical);
    }
  }
}

@mixin button-outline-disabled($outline-color) {
  background: transparent;
  box-shadow: none;
}

@mixin button-full-width {
  display: flex;
  width: 100%;
}

@mixin plain-button-backdrop {
  padding: 2px 5px;
  margin: -2px -5px;
  background: var(--p-action-secondary-hovered);
  border-radius: border-radius();
}

@mixin unstyled-button() {
  appearance: none;
  margin: 0;
  padding: 0;
  background: none;
  border: none;
  font-size: inherit;
  line-height: inherit;
  color: inherit;
  cursor: pointer;

  &:focus {
    outline: none;
  }
}
